<?php

define("WPEDEN_THEME_DIR",dirname(__FILE__));
define("WPEDEN_THEME_URL",get_stylesheet_directory_uri());
 
if ( ! isset( $content_width ) ) $content_width = 960;


include("admin/engine.php"); 
 

//Theme option menu function
function wpeden_theme_opt_menu(){                                                                                             /*Theme Option Menu*/
      add_theme_page( "WP Eden Settings", "WP Eden Settings", 'edit_theme_options', 'wp-eden', 'wpeden_opt');  
    }
    
    
//theme option     
function wpeden_opt(){                                                                                                  /*Theme Option Function*/      
        include("admin/general-settings.php");
        
    }
    
//save theme option    
function wpeden_save_theme_opt(){                                                                                                   /*Save Theme Option in an array*/
        if(isset($_POST['wpeden_act'])&&$_POST['wpeden_act']=='savethmopt') {    
        $wpeden_nonce = $_REQUEST['_wpeden_nonce'];
        if (! wp_verify_nonce($wpeden_nonce, 'wpeden-nonce') ) die('Invalid nonce'); 
        
        //validate and sanitize data before save        
        update_option("wpeden_thmopt_slider_cat",(int)$_POST['wpeden_thmopt_slider_cat']);                                 
        
        header("location: $_SERVER[HTTP_REFERER]");
        die('');   
        }
 
    }
            
 
//generate thumbnail 
function wpeden_thumb($post, $size='', $echo = true){    
    $size = $size?$size:'thumbnail';   
    $large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'large'); 
    $large_image_url = $large_image_url[0];
    $large_image_url = $large_image_url?$large_image_url:WPEDEN_THEME_URL.'/admin/images/no-image.png';
    if($echo)
    echo get_the_post_thumbnail($post->ID, $size );
    else 
    return get_the_post_thumbnail($post->ID, $size );  
} 

//post thumbnail function
function wpeden_post_thumb($size='', $echo = true){
    global $post;
    $size = $size?$size:'thumbnail';   
    $large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'large'); 
    $large_image_url = $large_image_url[0];
    if((is_single()||is_page())&&$large_image_url=='') return;
    $large_image_url = $large_image_url?$large_image_url:WPEDEN_THEME_URL.'/admin/images/no-image.png';    
    
    if($echo)
    echo get_the_post_thumbnail($post->ID, $size );
    else 
    return get_the_post_thumbnail($post->ID, $size );
}

//generate cutom excerpt
function wpeden_post_excerpt($length){
    global $post;
    $uexcerpt = $post->post_excerpt?$post->post_excerpt:$post->post_content;
    $uexcerpt = strip_tags($uexcerpt);
    $excerpt = substr($uexcerpt,0,$length);
    $eexcerpt = substr($uexcerpt,$length);
    $excerpt .= array_shift(explode(" ",$eexcerpt));
    echo $excerpt.'...';
}

//comments
function wpeden_comment($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; 
   $GLOBALS['comment'] = $comment;
    
    switch ( $comment->comment_type ) :
        case 'pingback' :
        case 'trackback' :
        ?>
    <li class="post pingback">
        <p><?php _e( 'Pingback:', 'wpeden' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __( 'Edit', 'wpeden' ), '<span class="edit-link">', '</span>' ); ?></p>
    <?php
        break;
        default :
   ?>
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">         
            <div class="comment-body">
               <div id="comment-<?php comment_ID(); ?>" class="clearfix">
                    <div class="author-box">
                        <?php echo get_avatar($comment,56); ?>
                         
                    </div> <!-- end .avatar-box -->
                    <div class="comment-wrap clearfix">                        
                        <div class="comment-meta commentmetadata">
                        <?php printf('<span class="fn">%s</span>', get_comment_author_link()) ?>
                        <a href="<?php echo esc_url( get_comment_link( $comment->comment_ID ) ); ?>">
                            <?php
                                /* translators: 1: date, 2: time */
                                printf( __( '%1$s at %2$s', 'wpeden' ), get_comment_date(),  get_comment_time() ); ?></a><?php edit_comment_link( __( '(Edit)', 'Feather' ), ' ' );
                            ?>
                        </div><!-- .comment-meta .commentmetadata -->

                        <?php if ($comment->comment_approved == '0') : ?>
                            <em class="moderation"><?php _e('Your comment is awaiting moderation.','Feather') ?></em>
                            <br />
                        <?php endif; ?>

                        <div class="comment-content"><?php comment_text() ?></div> <!-- end comment-content-->
                        <div class="reply-container"><?php comment_reply_link(array_merge( $args, array('reply_text' => __('Reply','Feather'),'depth' => $depth, 'max_depth' => $args['max_depth']))) ?></div>
                    </div> <!-- end comment-wrap-->
                    <div class="comment-arrow"></div>
                </div> <!-- end comment-body-->
            </div> <!-- end comment-body-->
         
 
<?php 
        break;
    endswitch;    
 }
 
 
 
 //Sidebars
 function wpeden_widget_init(){
     
    register_sidebar(array(
      'name' => 'Single Post',
      'id' => 'single_post_sidebar',
      'description' => 'Sidebar For Single post.',
      'before_widget' => '<div class="box widget">',
      'after_widget' => '</div>',
      'before_title' => '<h3>',
      'after_title' => '</h3>'
    ));
        
     register_sidebar(array(
      'name' => 'Archive Page',
      'id' => 'archive_page_sidebar',
      'description' => 'Sidebar For Archive Page.',
      'before_widget' => '<div class="box widget box_yellow">',
      'after_widget' => '</div>',
      'before_title' => '<h3>',
      'after_title' => '</h3>'
    ));    
       
    register_sidebar(array(
      'name' => 'Home Page',
      'id' => 'home_page_sidebar',
      'description' => 'Sidebar For Homepage.',
      'before_widget' => '<div class="box widget yellow_hard">',
      'after_widget' => '</div>',
      'before_title' => '<h3>',
      'after_title' => '</h3>'
    )); 
 }
 
 // wp_title filter
 function wpeden_filter_wp_title( $old_title, $sep, $sep_location ){
    $ssep = ' ' . $sep . ' ';
    // find the type of index page this is
    if( is_category() ) $insert = $ssep . 'Category';
    elseif( is_tag() ) $insert = $ssep . 'Tag';
    elseif( is_author() ) $insert = $ssep . 'Author';
    elseif( is_year() || is_month() || is_day() ) $insert = $ssep . 'Archives';
    else $insert = NULL;
     
    // get the page number we're on (index)
    if( get_query_var( 'paged' ) )
    $num = $ssep . 'page ' . get_query_var( 'paged' );
     
    // get the page number we're on (multipage post)
    elseif( get_query_var( 'page' ) )
    $num = $ssep . 'page ' . get_query_var( 'page' );
     
    // else
    else $num = NULL;
    
    $site_description = get_bloginfo( 'description', 'display' );
    if ( is_home() && $site_description )
    $old_title .=  $ssep  . $site_description;
     
    // concoct and return new title
    return get_bloginfo( 'name' ) . $insert . $old_title . $num;
}
 
 
//Theme setup function 
function wpeden_setup(){
    register_nav_menus( array(
        'primary' => __( 'Top Menu', 'wp-eden' ), 
        'footer' => __( 'Footer Menu', 'wp-eden' )   
    ) );
    
    add_theme_support( 'post-thumbnails' );
    if(has_post_format('aside'))
    add_theme_support("post-formats");
    add_theme_support("automatic-feed-links");
    add_theme_support("excerpt");
 
    add_image_size( 'wpeden-slider', 900, 300, true ); //300 pixels wide (and unlimited height)
    add_image_size( 'wpeden-homepage-thumb', 80, 80, true ); //(cropped)
    add_image_size( 'wpeden-post-thumb', 610, 99999, true ); //(cropped)
 
 }
 
 function wpeden_enqueue_scripts(){
    wp_enqueue_style('wpeden-cs',get_stylesheet_directory_uri().'/css/superfish.css');   
    wp_enqueue_script('wpeden-js1',get_stylesheet_directory_uri().'/js/superfish.js');     
    wp_enqueue_script('wpeden-js2',get_stylesheet_directory_uri().'/js/hoverIntent.js');       
 }



add_action( 'wp_enqueue_scripts', 'wpeden_enqueue_scripts');
add_action("init","wpeden_save_theme_opt");
add_action('admin_menu', 'wpeden_theme_opt_menu');
add_filter( 'wp_title', 'wpeden_filter_wp_title', 10, 3 );
add_action( 'init', 'wpeden_widget_init' );  
add_action( 'after_setup_theme', 'wpeden_setup' );  
 
